



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Linux性能研究（总）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Linux性能研究（总）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-07 23:11:12 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>http://www.vpsee.com/2009/11/linux-system-performance-monitoring-introduction/</p>
<p>http://www.jb51.net/LINUXjishu/34607.html</p>
<p>公司有个测试服务器，上面跑了几个应用和一个DB。 DB被这个几个应用使用。 最近老是被挂掉。 CPU 使用率100%。 搞到最后大家都不能用。</p>
<p>敲个命令都没反应。&nbsp;TOP命令显示的是一些Oracle session占用CPU资源太多。&nbsp;杯具的是在服务器上连sqlplus&nbsp;都进不去了，命令都没反应。&nbsp;只好把服务器重启了。&nbsp;重启之后再看了一下，是一个同事测试的SQL&nbsp;有问题。&nbsp;一条SQL&nbsp;占用CPU&nbsp;就30%。</p>
<p>在研究这个问题的时候，也google到了一些Linux&nbsp;下的监控事项，整理如下。</p>
<p><strong>一.&nbsp;&nbsp;Linux&nbsp;性能监控的概述</strong></p>
<p>看了某某教程、读了某某手册，按照要求改改某某设置、系统设定、内核参数就认为做到系统优化的想法很傻很天真：）系统优化是一项复杂、繁琐、长期的工作，优化前需要监测、采集、测试、评估，优化后也需要测试、采集、评估、监测，而且是一个长期和持续的过程，不是说现在优化了，测试了，以后就可以一劳永逸了，也不是说书本上的优化就适合眼下正在运行的系统，不同的系统、不同的硬件、不同的应用优化的重点也不同、优化的方法也不同、优化的参数也不同。性能监测是系统优化过程中重要的一环，如果没有监测、不清楚性能瓶颈在哪里，优化什么呢、怎么优化呢？所以找到性能瓶颈是性能监测的目的，也是系统优化的关键。系统由若干子系统构成，通常修改一个子系统有可能影响到另外一个子系统，甚至会导致整个系统不稳定、崩溃。所以说优化、监测、测试通常是连在一起的，而且是一个循环而且长期的过程，通常监测的子系统有以下这些：</p>
<p>（1）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;CPU</p>
<p>（2）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Memory</p>
<p>（3）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;IO</p>
<p>（4）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Network</p>
<p>这些子系统互相依赖，了解这些子系统的特性，监测这些子系统的性能参数以及及时发现可能会出现的瓶颈对系统优化很有帮助。</p>
<p><strong>1.1&nbsp;&nbsp;应用类型</strong></p>
<p>不同的系统用途也不同，要找到性能瓶颈需要知道系统跑的是什么应用、有些什么特点，比如&nbsp;web server&nbsp;对系统的要求肯定和&nbsp;file server&nbsp;不一样，所以分清不同系统的应用类型很重要，通常应用可以分为两种类型：</p>
<p>（1）IO&nbsp;相关，IO&nbsp;相关的应用通常用来处理大量数据，需要大量内存和存储，频繁&nbsp;IO&nbsp;操作读写数据，而对&nbsp;CPU&nbsp;的要求则较少，大部分时候&nbsp;CPU&nbsp;都在等待硬盘，比如，数据库服务器、文件服务器等。</p>
<p>（2）CPU&nbsp;相关，CPU&nbsp;相关的应用需要使用大量&nbsp;CPU，比如高并发的&nbsp;web/mail&nbsp;服务器、图像/视频处理、科学计算等都可被视作&nbsp;CPU&nbsp;相关的应用。</p>
<p>看看实际中的例子，第1个是文件服务器拷贝一个大文件时表现出来的特征：</p>
<pre class="prettyprint linenums">$ vmstat 1</pre>
<pre class="prettyprint linenums">procs -----------memory---------- ---swap-- -----io---- --system-- -----cpu------</pre>
<pre class="prettyprint linenums"> r&nbsp; b&nbsp;&nbsp; swpd&nbsp;&nbsp; free&nbsp;&nbsp; buff&nbsp; cache&nbsp;&nbsp; si&nbsp;&nbsp; so&nbsp;&nbsp;&nbsp; bi&nbsp;&nbsp;&nbsp; bo&nbsp;&nbsp; in&nbsp;&nbsp; cs us sy id wa st</pre>
<pre class="prettyprint linenums"> 0&nbsp; 4&nbsp;&nbsp;&nbsp; 140 1962724 335516 4852308&nbsp; 0&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp; 388 65024 1442&nbsp; 563&nbsp; 0&nbsp; 2 47 52&nbsp; 0</pre>
<pre class="prettyprint linenums"> 0&nbsp; 4&nbsp;&nbsp;&nbsp; 140 1961816 335516 4853868&nbsp; 0&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp; 768 65536 1434&nbsp; 522&nbsp; 0&nbsp; 1 50 48&nbsp; 0</pre>
<pre class="prettyprint linenums"> 0&nbsp; 4&nbsp;&nbsp;&nbsp; 140 1960788 335516 4855300&nbsp; 0&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp; 768 48640 1412&nbsp; 573&nbsp; 0&nbsp; 1 50 49&nbsp; 0</pre>
<pre class="prettyprint linenums"> 0&nbsp; 4&nbsp;&nbsp;&nbsp; 140 1958528 335516 4857280&nbsp; 0&nbsp;&nbsp;&nbsp; 0&nbsp; 1024 65536 1415 &nbsp;521&nbsp; 0&nbsp; 1 41 57&nbsp; 0</pre>
<pre class="prettyprint linenums"> 0&nbsp; 5&nbsp;&nbsp;&nbsp; 140 1957488 335516 4858884&nbsp; 0&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp; 768 81412 1504&nbsp; 609&nbsp; 0&nbsp; 2 50 49&nbsp; 0</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<p>第2个是&nbsp;CPU&nbsp;做大量计算时表现出来的特征：</p>
<pre class="prettyprint linenums">$ vmstat 1</pre>
<pre class="prettyprint linenums">procs -----------memory---------- ---swap-- -----io---- --system-- -----cpu------</pre>
<pre class="prettyprint linenums"> r&nbsp; b&nbsp;&nbsp; swpd&nbsp;&nbsp; free&nbsp;&nbsp; buff&nbsp; cache&nbsp;&nbsp; si&nbsp;&nbsp; so&nbsp;&nbsp;&nbsp; bi&nbsp;&nbsp;&nbsp; bo&nbsp;&nbsp; in&nbsp; &nbsp;cs us sy id wa st</pre>
<pre class="prettyprint linenums"> 4&nbsp; 0&nbsp;&nbsp;&nbsp; 140 3625096 334256 3266584&nbsp; 0&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp; 16 1054&nbsp; 470 100 0&nbsp; 0&nbsp; 0&nbsp; 0</pre>
<pre class="prettyprint linenums"> 4&nbsp; 0&nbsp;&nbsp;&nbsp; 140 3625220 334264 3266576&nbsp; 0&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp; 12 1037&nbsp; 448 100 0&nbsp; 0&nbsp; 0&nbsp; 0</pre>
<pre class="prettyprint linenums"> 4&nbsp; 0&nbsp;&nbsp;&nbsp; 140 3624468 334264 3266580&nbsp; 0&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp; 148 1160&nbsp; 632 100 0&nbsp; 0 &nbsp;0&nbsp; 0</pre>
<pre class="prettyprint linenums"> 4&nbsp; 0&nbsp;&nbsp;&nbsp; 140 3624468 334264 3266580&nbsp; 0&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp; 0 1078&nbsp; 527 100 0&nbsp; 0&nbsp; 0&nbsp; 0</pre>
<pre class="prettyprint linenums"> 4&nbsp; 0&nbsp;&nbsp;&nbsp; 140 3624712 334264 3266580&nbsp; 0&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp; 80 1053&nbsp; 501 100 0&nbsp; 0&nbsp; 0&nbsp; 0</pre>
<p>上面两个例子最明显的差别就是&nbsp;id&nbsp;一栏，代表&nbsp;CPU&nbsp;的空闲率，拷贝文件时候&nbsp;id&nbsp;维持在&nbsp;50％&nbsp;左右，CPU&nbsp;大量计算的时候&nbsp;id&nbsp;基本为&nbsp;0。</p>
<p><strong>1.2&nbsp;&nbsp;底线</strong></p>
<p>事先建立一个底线，如果性能监测得到的统计数据跨过这条线，我们就可以说这个系统性能差，如果数据能保持在线内我们就说性能好。建立这样底线需要知道一些理论、额外的负载测试和系统管理员多年的经验。如果自己没有多年的经验，有一个简单划底线的办法就是：把这个底线建立在自己对系统的期望上。自己期望这个系统有个什么样的性能，这是一个底线，如果没有达到这个要求就是性能差。</p>
<p>比如，VPSee&nbsp;上个月有个 RAID0 的测试，期望的测试结果应该是 RAID0 的 IO 性能比单硬盘有显著提高，底线是 RAID0 的 IO 至少要比单硬盘要好（好多少不重要，底线是至少要好），测试结果却发现 RAID0 性能还不如单硬盘，说明性能差，这个时候需要问个为什么，这往往是性能瓶颈所在，经过排查发现是原硬盘有硬件瑕疵造成性能测试结果错误。</p>
<p><strong>1.3&nbsp;&nbsp;监测工具</strong></p>
<table>
<thead>
<tr>
<td>
<p>工具</p>
</td>
<td>
<p>简单介绍</p>
</td>
</tr>
</thead>
<tbody>
<tr>
<td>
<p>top</p>
</td>
<td>
<p>查看进程活动状态以及一些系统状况</p>
</td>
</tr>
<tr>
<td>
<p>vmstat</p>
</td>
<td>
<p>查看系统状态、硬件和系统信息等</p>
</td>
</tr>
<tr>
<td>
<p>iostat</p>
</td>
<td>
<p>查看CPU&nbsp;负载，硬盘状况</p>
</td>
</tr>
<tr>
<td>
<p>sar</p>
</td>
<td>
<p>综合工具，查看系统状况</p>
</td>
</tr>
<tr>
<td>
<p>mpstat</p>
</td>
<td>
<p>查看多处理器状况</p>
</td>
</tr>
<tr>
<td>
<p>netstat</p>
</td>
<td>
<p>查看网络状况</p>
</td>
</tr>
<tr>
<td>
<p>iptraf</p>
</td>
<td>
<p>实时网络状况监测</p>
</td>
</tr>
<tr>
<td>
<p>tcpdump</p>
</td>
<td>
<p>抓取网络数据包，详细分析</p>
</td>
</tr>
<tr>
<td>
<p>mpstat</p>
</td>
<td>
<p>查看多处理器状况</p>
</td>
</tr>
<tr>
<td>
<p>tcptrace</p>
</td>
<td>
<p>数据包分析工具</p>
</td>
</tr>
<tr>
<td>
<p>netperf</p>
</td>
<td>
<p>网络带宽工具</p>
</td>
</tr>
<tr>
<td>
<p>dstat</p>
</td>
<td>
<p>综合工具，综合了&nbsp;vmstat, iostat, ifstat, netstat&nbsp;等多个信息</p>
</td>
</tr>
</tbody>
</table>
<p><strong>二. CPU</strong></p>
<p>CPU&nbsp;的占用主要取决于什么样的资源正在&nbsp;CPU&nbsp;上面运行，比如拷贝一个文件通常占用较少&nbsp;CPU，因为大部分工作是由&nbsp;DMA（Direct Memory Access）完成，只是在完成拷贝以后给一个中断让&nbsp;CPU&nbsp;知道拷贝已经完成；科学计算通常占用较多的&nbsp;CPU，大部分计算工作都需要在&nbsp;CPU&nbsp;上完成，内存、硬盘等子系统只做暂时的数据存储工作。要想监测和理解&nbsp;CPU&nbsp;的性能需要知道一些的操作系统的基本知识，比如：中断、进程调度、进程上下文切换、可运行队列等。&nbsp;&nbsp;&nbsp;&nbsp;这里用个例子来简单介绍一下这些概念和他们的关系，CPU每时每刻都有工作在做（进程、线程）并且自己有一张工作清单（可运行队列），由老板（进程调度）来决定他该干什么，他需要和老板沟通以便得到老板的想法并及时调整自己的工作（上下文切换），部分工作做完以后还需要及时向老板汇报（中断），所以打工仔（CPU）除了做自己该做的工作以外，还有大量时间和精力花在沟通和汇报上。</p>
<p>CPU&nbsp;也是一种硬件资源，和任何其他硬件设备一样也需要驱动和管理程序才能使用，我们可以把操作系统内核的进程调度看作是&nbsp;CPU&nbsp;的管理程序，用来管理和分配&nbsp;CPU&nbsp;资源，合理安排进程抢占&nbsp;CPU，并决定哪个进程该使用&nbsp;CPU、哪个进程该等待。<strong>操作系统内核里的进程调度主要用来调度两类资源：进程（或线程）和中断，进程调度给不同的资源分配了不同的优先级，优先级最高的是硬件中断，其次是内核（系统）进程，最后是用户进程。每个&nbsp;CPU&nbsp;都维护着一个可运行队列，用来存放那些可运行的线程。线程要么在睡眠状态（blocked&nbsp;正在等待&nbsp;IO）要么在可运行状态，如果&nbsp;CPU&nbsp;当前负载太高而新的请求不断，就会出现进程调度暂时应付不过来的情况，这个时候就不得不把线程暂时放到可运行队列里。</strong></p>
<p>那么这些概念和性能监测有什么关系呢？关系重大。如果你是老板，你如何检查打工仔的效率（性能）呢？我们一般会通过以下这些信息来判断打工仔是否偷懒：</p>
<ul><li>打工仔接受和完成多少任务并向老板汇报了（中断）；</li>
<li>打工仔和老板沟通、协商每项工作的工作进度（上下文切换）；</li>
<li>打工仔的工作列表是不是都有排满（可运行队列）；</li>
<li>打工仔工作效率如何，是不是在偷懒（CPU 利用率）。</li></ul>
<p>现在把打工仔换成 CPU，我们可以通过查看这些重要参数：中断、上下文切换、可运行队列、CPU 利用率来监测 CPU 的性能。</p>
<p>可以从以下几个方面监控CPU的信息：</p>
<p>（1）中断；</p>
<p>（2）上下文切换；</p>
<p>（3）可运行队列；</p>
<p>（4）CPU&nbsp;利用率。</p>
<p><strong>2.1&nbsp;底线</strong></p>
<p>通常我们期望我们的系统能到达以下目标：</p>
<p>（1）CPU&nbsp;利用率，如果&nbsp;CPU&nbsp;有&nbsp;100％&nbsp;利用率，那么应该到达这样一个平衡：65％－70％&nbsp;User Time，30％－35％&nbsp;System Time，0％－5％&nbsp;Idle Time；</p>
<p>（2）上下文切换，上下文切换应该和&nbsp;CPU&nbsp;利用率联系起来看，如果能保持上面的&nbsp;CPU&nbsp;利用率平衡，大量的上下文切换是可以接受的。上下文切换：如果过于频繁，说明系统把大量的时间用在线程的切换上了，那么每个线程的执行时间过短，也就是说，系统执行的有效代码少。如果cpu很牛，切换多点也没事，但是肯定频繁切换还是会影响性能。</p>
<p>（3）可运行队列，每个可运行队列不应该有超过1－3个线程（每处理器），比如：双处理器系统的可运行队列里不应该超过6个线程。</p>
<p><strong>2.2&nbsp;&nbsp;vmstat</strong></p>
<p>vmstat&nbsp;是个查看系统整体性能的小工具，小巧、即使在很&nbsp;heavy&nbsp;的情况下也运行良好，并且可以用时间间隔采集得到连续的性能数据。</p>
<pre class="prettyprint linenums">$ vmstat 1</pre>
<pre class="prettyprint linenums">procs -----------memory---------- ---swap-- -----io---- --system-- -----cpu------</pre>
<pre class="prettyprint linenums"> r&nbsp; b&nbsp;&nbsp; swpd&nbsp;&nbsp; free&nbsp;&nbsp; buff&nbsp; cache&nbsp;&nbsp; si&nbsp;&nbsp; so&nbsp;&nbsp;&nbsp; bi&nbsp;&nbsp;&nbsp; bo&nbsp;&nbsp; in&nbsp;&nbsp; cs us sy id wa st</pre>
<pre class="prettyprint linenums"> 2&nbsp; 1&nbsp;&nbsp;&nbsp; 140 2787980 336304 3531996&nbsp; 0&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp; 128 1166 5033&nbsp; 3&nbsp; 3 70 25&nbsp; 0</pre>
<pre class="prettyprint linenums"> 0&nbsp; 1&nbsp;&nbsp;&nbsp; 140 2788296 336304 3531996&nbsp; 0&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp; 0 1194 5605 &nbsp;3&nbsp; 3 69 25&nbsp; 0</pre>
<pre class="prettyprint linenums"> 0&nbsp; 1&nbsp;&nbsp;&nbsp; 140 2788436 336304 3531996&nbsp; 0&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp; 0 1249 8036&nbsp; 5&nbsp; 4 67 25&nbsp; 0</pre>
<pre class="prettyprint linenums"> 0&nbsp; 1&nbsp;&nbsp;&nbsp; 140 2782688 336304 3531996&nbsp; 0&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp; 0 1333 7792&nbsp; 6&nbsp; 6 64 25&nbsp; 0</pre>
<pre class="prettyprint linenums"> 3&nbsp; 1&nbsp;&nbsp;&nbsp; 140 2779292 336304 3531992&nbsp; 0&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp; 28 1323 7087&nbsp; 4&nbsp; 5 67 25&nbsp; 0</pre>
<p>参数介绍：</p>
<p>（1）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;r，可运行队列的线程数，这些线程都是可运行状态，只不过&nbsp;CPU&nbsp;暂时不可用；</p>
<p>（2）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;b，被&nbsp;blocked&nbsp;的进程数，正在等待&nbsp;IO&nbsp;请求；</p>
<p>（3）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;in，被处理过的中断数</p>
<p>（4）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;cs，系统上正在做上下文切换的数目</p>
<p>（5）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;us，用户占用&nbsp;CPU&nbsp;的百分比</p>
<p>（6）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;sys，内核和中断占用&nbsp;CPU&nbsp;的百分比</p>
<p>（7）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;wa，所有可运行的线程被&nbsp;blocked&nbsp;以后都在等待&nbsp;IO，这时候&nbsp;CPU&nbsp;空闲的百分比</p>
<p>（8）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;id，CPU&nbsp;完全空闲的百分比</p>
<p>举两个现实中的例子来实际分析一下：</p>
<pre class="prettyprint linenums">$ vmstat 1</pre>
<pre class="prettyprint linenums">procs -----------memory---------- ---swap-- -----io---- --system-- -----cpu------</pre>
<pre class="prettyprint linenums"> r&nbsp; b&nbsp;&nbsp; swpd&nbsp;&nbsp; free&nbsp;&nbsp; buff&nbsp; cache&nbsp;&nbsp; si&nbsp;&nbsp; so&nbsp;&nbsp;&nbsp; bi&nbsp;&nbsp;&nbsp; bo&nbsp;&nbsp; in&nbsp;&nbsp; cs us sy id wa st</pre>
<pre class="prettyprint linenums"> 4&nbsp; 0&nbsp;&nbsp;&nbsp; 140 2915476 341288 3951700&nbsp; 0&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp; 0 1057&nbsp; 523 19 81&nbsp; 0&nbsp; 0&nbsp; 0</pre>
<pre class="prettyprint linenums"> 4&nbsp; 0&nbsp;&nbsp;&nbsp; 140 2915724 341296 3951700&nbsp; 0&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp; 0 1048&nbsp; 546 19 81&nbsp; 0&nbsp; 0&nbsp; 0</pre>
<pre class="prettyprint linenums"> 4&nbsp; 0&nbsp;&nbsp;&nbsp; 140 2915848 341296 3951700&nbsp; 0&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp; 0 1044&nbsp; 514 18 82&nbsp; 0&nbsp; 0&nbsp; 0</pre>
<pre class="prettyprint linenums"> 4&nbsp; 0&nbsp;&nbsp;&nbsp; 140 2915848 341296 3951700&nbsp; 0&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp; 24 1044&nbsp; 564 20 80&nbsp; 0&nbsp; 0&nbsp; 0</pre>
<pre class="prettyprint linenums"> 4&nbsp; 0&nbsp;&nbsp;&nbsp; 140 2915848 341296 3951700&nbsp; 0&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp; &nbsp;&nbsp;0&nbsp;&nbsp;&nbsp;&nbsp; 0 1060&nbsp; 546 18 82&nbsp; 0&nbsp; 0&nbsp; 0</pre>
<p>从上面的数据可以看出几点：</p>
<p>（1）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;interrupts（in）非常高，context switch（cs）比较低，说明这个&nbsp;CPU&nbsp;一直在不停的请求资源；</p>
<p>（2）. &nbsp; &nbsp; &nbsp;system time（sy）一直保持在 80％ 以上，而且上下文切换较低（cs），说明某个进程可能一直霸占着&nbsp;CPU；</p>
<p>（3）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;run queue（r）刚好在4个。</p>
<pre class="prettyprint linenums">$ vmstat 1</pre>
<pre class="prettyprint linenums">procs -----------memory---------- ---swap-- -----io---- --system-- -----cpu------</pre>
<pre class="prettyprint linenums"> r&nbsp; b&nbsp;&nbsp; swpd&nbsp;&nbsp; free&nbsp;&nbsp; buff&nbsp; cache&nbsp;&nbsp; si&nbsp;&nbsp; so&nbsp;&nbsp;&nbsp; bi&nbsp;&nbsp;&nbsp; bo&nbsp;&nbsp; in&nbsp;&nbsp; cs us sy id wa st</pre>
<pre class="prettyprint linenums">14&nbsp; 0&nbsp;&nbsp;&nbsp; 140 2904316 341912 3952308&nbsp; 0&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp; 460 1106 9593 36 64&nbsp; 1&nbsp; 0&nbsp; 0</pre>
<pre class="prettyprint linenums">17&nbsp; 0&nbsp;&nbsp;&nbsp; 140 2903492 341912 3951780&nbsp; 0&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp; 0 1037 9614 35 65&nbsp; 1&nbsp; 0&nbsp; 0</pre>
<pre class="prettyprint linenums">20&nbsp; 0&nbsp;&nbsp;&nbsp; 140 2902016 341912 3952000&nbsp; 0&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp; 0 1046 9739 35 64&nbsp; 1&nbsp; 0&nbsp; 0</pre>
<pre class="prettyprint linenums">17&nbsp; 0&nbsp;&nbsp;&nbsp; 140 2903904 341912 3951888&nbsp; 0&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp; 76 1044 9879 37 63&nbsp; 0&nbsp; 0&nbsp; 0</pre>
<pre class="prettyprint linenums">16&nbsp; 0&nbsp;&nbsp;&nbsp; 140 2904580 341912 3952108&nbsp; 0&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp; 0 1055 9808 34 65&nbsp; 1&nbsp; 0&nbsp; 0</pre>
<p>从上面的数据可以看出几点：</p>
<p>（1）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;context switch（cs）比&nbsp;interrupts（in）要高得多，说明内核不得不来回切换进程；</p>
<p>（2）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;进一步观察发现&nbsp;system time（sy）很高而&nbsp;user time（us）很低，而且加上高频度的上下文切换（cs），</p>
<p>说明正在运行的应用程序调用了大量的系统调用（system call）；</p>
<p>（3）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;run queue（r）在14个线程以上，按照这个测试机器的硬件配置（四核），应该保持在12个以内。</p>
<p>我上午CPU 100%时的信息：</p>
<p>top - 11:49:08 up 50 days, 22:25,&nbsp;&nbsp;6 users,&nbsp;&nbsp;load average: 59.79, 59.98, 60.50</p>
<p>Tasks: 200 total,&nbsp;&nbsp;61 running, 139 sleeping,&nbsp;&nbsp;&nbsp;0 stopped,&nbsp;&nbsp;&nbsp;0 zombie</p>
<p>Cpu0&nbsp;&nbsp;: 26.5%us, 73.5%sy,&nbsp;&nbsp;0.0%ni,&nbsp;&nbsp;0.0%id,&nbsp;&nbsp;0.0%wa,&nbsp;&nbsp;0.0%hi,&nbsp;&nbsp;0.0%si,&nbsp;&nbsp;0.0%st</p>
<p>Cpu1&nbsp;&nbsp;: 25.0%us, 75.0%sy,&nbsp;&nbsp;0.0%ni,&nbsp;&nbsp;0.0%id,&nbsp;&nbsp;0.0%wa,&nbsp;&nbsp;0.0%hi,&nbsp;&nbsp;0.0%si,&nbsp;&nbsp;0.0%st</p>
<p>Mem:&nbsp;&nbsp;&nbsp;1939780k total,&nbsp;&nbsp;1744412k used,&nbsp;&nbsp;&nbsp;195368k free,&nbsp;&nbsp;&nbsp;&nbsp;95704k buffers</p>
<p>Swap:&nbsp;&nbsp;4401800k total,&nbsp;&nbsp;&nbsp;662836k used,&nbsp;&nbsp;3738964k free,&nbsp;&nbsp;&nbsp;811124k cached</p>
<p>[root@localhost ~]# vmstat 2 10</p>
<p>procs -----------memory---------- ---swap-- -----io---- --system-- -----cpu------</p>
<p>r&nbsp;&nbsp;b&nbsp;&nbsp;&nbsp;swpd&nbsp;&nbsp;&nbsp;free&nbsp;&nbsp;&nbsp;buff&nbsp;&nbsp;cache&nbsp;&nbsp;&nbsp;si&nbsp;&nbsp;&nbsp;so&nbsp;&nbsp;&nbsp;&nbsp;bi&nbsp;&nbsp;&nbsp;&nbsp;bo&nbsp;&nbsp;&nbsp;in&nbsp;&nbsp;&nbsp;cs us sy id wa st</p>
<p>58&nbsp;&nbsp;1 662836 195988&nbsp;&nbsp;95428 810740&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;4&nbsp;&nbsp;&nbsp;106&nbsp;&nbsp;&nbsp;&nbsp;4&nbsp;&nbsp;&nbsp;&nbsp;1 23&nbsp;&nbsp;4 72&nbsp;&nbsp;1&nbsp;&nbsp;0</p>
<p>59&nbsp;&nbsp;1 662836 195988&nbsp;&nbsp;95448 810732&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;&nbsp;&nbsp;128&nbsp;&nbsp;235&nbsp;&nbsp;221 28 72&nbsp;&nbsp;0&nbsp;&nbsp;0&nbsp;&nbsp;0</p>
<p>59&nbsp;&nbsp;1 662836 195988&nbsp;&nbsp;95448 810768&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;&nbsp;216&nbsp;&nbsp;209 28 72&nbsp;&nbsp;0&nbsp;&nbsp;0&nbsp;&nbsp;0</p>
<p><strong>2.3&nbsp;&nbsp;mpstat</strong></p>
<p>mpstat&nbsp;和&nbsp;vmstat&nbsp;类似，不同的是&nbsp;mpstat&nbsp;可以输出多个处理器的数据。</p>
<p>注意：需要安装sysstat&nbsp;包后才有这个命令，可以使用yum安装：</p>
<p>#yum install sysstat</p>
<p>sysstat&nbsp;包含iostat、mpstat、sar、命令。</p>
<pre class="prettyprint linenums">[root@localhost gmail]# export LANG=en_US</pre>
<pre class="prettyprint linenums">[root@localhost gmail]# mpstat -P ALL&nbsp;&nbsp;&nbsp; </pre>
<pre class="prettyprint linenums">Linux 2.6.18-8.el5xen (localhost.localdomain)&nbsp;&nbsp; 02/21/2011</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">10:20:16 PM&nbsp; CPU&nbsp;&nbsp; %user&nbsp;&nbsp; %nice&nbsp;&nbsp;&nbsp; %sys %iowait&nbsp;&nbsp;&nbsp; %irq&nbsp;&nbsp; %soft&nbsp; %steal&nbsp;&nbsp; %idle&nbsp;&nbsp;&nbsp; intr/s</pre>
<pre class="prettyprint linenums">10:20:16 PM&nbsp; all&nbsp;&nbsp; 11.49&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 2.58&nbsp;&nbsp;&nbsp; 1.04&nbsp;&nbsp;&nbsp; 0.01&nbsp;&nbsp;&nbsp; 0.13&nbsp;&nbsp;&nbsp; 0.01&nbsp;&nbsp; 84.74&nbsp;&nbsp;&nbsp; 314.61</pre>
<pre class="prettyprint linenums">10:20:16 PM&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp; 15.73&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 2.56&nbsp;&nbsp;&nbsp; 0.55&nbsp;&nbsp;&nbsp; 0.02&nbsp;&nbsp;&nbsp; 0.23&nbsp;&nbsp;&nbsp; 0.01&nbsp; &nbsp;80.89&nbsp;&nbsp;&nbsp; 241.09</pre>
<pre class="prettyprint linenums">10:20:16 PM&nbsp;&nbsp;&nbsp; 1&nbsp;&nbsp;&nbsp; 7.25&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 2.60&nbsp;&nbsp;&nbsp; 1.53&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.02&nbsp;&nbsp;&nbsp; 0.01&nbsp;&nbsp; 88.59&nbsp;&nbsp;&nbsp;&nbsp; 73.52</pre>
<pre class="prettyprint linenums">[root@localhost gmail]# mpstat -P ALL 1</pre>
<pre class="prettyprint linenums">Linux 2.6.18-8.el5xen (localhost.localdomain)&nbsp;&nbsp; 02/21/2011</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">10:20:18 PM&nbsp; CPU&nbsp;&nbsp; %user&nbsp;&nbsp; %nice&nbsp;&nbsp;&nbsp; %sys %iowait&nbsp;&nbsp;&nbsp; %irq&nbsp;&nbsp; %soft&nbsp; %steal&nbsp;&nbsp; %idle&nbsp;&nbsp;&nbsp; intr/s</pre>
<pre class="prettyprint linenums">10:20:19 PM&nbsp; all&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp; 100.00&nbsp;&nbsp;&nbsp; 136.63</pre>
<pre class="prettyprint linenums">10:20:19 PM&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp; 100.00&nbsp;&nbsp;&nbsp;&nbsp; 86.14</pre>
<pre class="prettyprint linenums">10:20:19 PM&nbsp;&nbsp;&nbsp; 1&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp; 100.00&nbsp;&nbsp;&nbsp;&nbsp; 50.50</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">10:20:19 PM&nbsp; CPU&nbsp;&nbsp; %user&nbsp;&nbsp; %nice&nbsp;&nbsp;&nbsp; %sys %iowait&nbsp;&nbsp;&nbsp; %irq&nbsp;&nbsp; %soft&nbsp; %steal&nbsp;&nbsp; %idle&nbsp;&nbsp;&nbsp; intr/s</pre>
<pre class="prettyprint linenums">10:20:20 PM&nbsp; all&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.47&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp; 99.53&nbsp;&nbsp;&nbsp; 105.00</pre>
<pre class="prettyprint linenums">10:20:20 PM&nbsp; &nbsp;&nbsp;0&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp; 100.00&nbsp;&nbsp;&nbsp;&nbsp; 79.00</pre>
<pre class="prettyprint linenums">10:20:20 PM&nbsp;&nbsp;&nbsp; 1&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.90&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp; 99.10&nbsp;&nbsp;&nbsp;&nbsp; 26.00</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<p><strong>2.4&nbsp;&nbsp;ps</strong></p>
<p>查看某个程序、进程占用了多少&nbsp;CPU&nbsp;资源</p>
<p>当前只有3个程序在使用 oracle</p>
<pre class="prettyprint linenums">[root@localhost gmail]#&nbsp; while :; do ps -eo pid,ni,pri,pcpu,psr,comm | grep 'oracle'; sleep 1; done</pre>
<pre class="prettyprint linenums">&nbsp; PID &nbsp;NI PRI %CPU PSR COMMAND</pre>
<pre class="prettyprint linenums"> 3668&nbsp;&nbsp; 0&nbsp; 24&nbsp; 0.0&nbsp;&nbsp; 0 oracle</pre>
<pre class="prettyprint linenums"> 3670&nbsp;&nbsp; 0&nbsp; 21&nbsp; 0.0&nbsp;&nbsp; 0 oracle</pre>
<pre class="prettyprint linenums"> 3672&nbsp;&nbsp; 0&nbsp; 24&nbsp; 0.0&nbsp;&nbsp; 0 oracle</pre>
<pre class="prettyprint linenums"> 3674&nbsp;&nbsp; 0&nbsp; 23&nbsp; 0.0 &nbsp;&nbsp;0 oracle</pre>
<pre class="prettyprint linenums"> 3676&nbsp;&nbsp; 0&nbsp; 24&nbsp; 0.0&nbsp;&nbsp; 1 oracle</pre>
<pre class="prettyprint linenums"> 3678&nbsp;&nbsp; 0&nbsp; 23&nbsp; 0.0&nbsp;&nbsp; 0 oracle</pre>
<pre class="prettyprint linenums"> 3680&nbsp;&nbsp; 0&nbsp; 21&nbsp; 0.0&nbsp;&nbsp; 1 oracle</pre>
<pre class="prettyprint linenums"> 3682&nbsp;&nbsp; 0&nbsp; 24&nbsp; 0.0&nbsp;&nbsp; 1 oracle</pre>
<pre class="prettyprint linenums"> 3684&nbsp;&nbsp; 0&nbsp; 24&nbsp; 0.0&nbsp;&nbsp; 0 oracle</pre>
<pre class="prettyprint linenums"> 3686&nbsp;&nbsp; 0&nbsp; 21&nbsp; 0.0&nbsp;&nbsp; 0 oracle</pre>
<p><strong>三. Memory</strong></p>
<p>这里的讲到的&nbsp;&ldquo;内存&rdquo;&nbsp;包括物理内存和虚拟内存，虚拟内存（Virtual Memory）把计算机的内存空间扩展到硬盘，物理内存（RAM）和硬盘的一部分空间（SWAP）组合在一起作为虚拟内存为计算机提供了一个连贯的虚拟内存空间，好处是我们拥有的内存&nbsp;&rdquo;变多了&ldquo;，可以运行更多、更大的程序，坏处是把部分硬盘当内存用整体性能受到影响，硬盘读写速度要比内存慢几个数量级，并且&nbsp;RAM&nbsp;和&nbsp;SWAP之间的交换增加了系统的负担。</p>
<p><strong>&nbsp;在操作系统里，虚拟内存被分成页，在&nbsp;x86&nbsp;系统上每个页大小是&nbsp;4KB。</strong>&nbsp;Linux&nbsp;内核读写虚拟内存是以&nbsp;&ldquo;页&rdquo;&nbsp;为单位操作的，把内存转移到硬盘交换空间（SWAP）和从交换空间读取到内存的时候都是按页来读写的。内存和&nbsp;SWAP&nbsp;的这种交换过程称为页面交换（Paging），值得注意的是&nbsp;paging&nbsp;和&nbsp;swapping&nbsp;是两个完全不同的概念，国内很多参考书把这两个概念混为一谈，swapping&nbsp;也翻译成交换，在操作系统里是指把某程序完全交换到硬盘以腾出内存给新程序使用，和&nbsp;paging&nbsp;只交换程序的部分（页面）是两个不同的概念。纯粹的&nbsp;swapping&nbsp;在现代操作系统中已经很难看到了，因为把整个程序交换到硬盘的办法既耗时又费力而且没必要，现代操作系统基本都是&nbsp;paging&nbsp;或者&nbsp;paging/swapping&nbsp;混合，swapping&nbsp;最初是在&nbsp;Unix system V&nbsp;上实现的。</p>
<p>在这里只介绍和性能监测有关的<strong>两个内核进程：kswapd&nbsp;和&nbsp;pdflush。</strong></p>
<p>（1）kswapd daemon&nbsp;用来检查&nbsp;pages_high&nbsp;和&nbsp;pages_low，如果可用内存少于&nbsp;pages_low，kswapd&nbsp;就开始扫描并试图释放&nbsp;32个页面，并且重复扫描释放的过程直到可用内存大于&nbsp;pages_high&nbsp;为止。</p>
<p>扫描的时候检查3件事：</p>
<p>1）如果页面没有修改，把页放到可用内存列表里；</p>
<p>2）如果页面被文件系统修改，把页面内容写到磁盘上；</p>
<p>3）如果页面被修改了，但不是被文件系统修改的，把页面写到交换空间。</p>
<p>（2）pdflush daemon&nbsp;用来同步文件相关的内存页面，把内存页面及时同步到硬盘上。比如打开一个文件，文件被导入到内存里，对文件做了修改后并保存后，内核并不马上保存文件到硬盘，由&nbsp;pdflush&nbsp;决定什么时候把相应页面写入硬盘，这由一个内核参数&nbsp;vm.dirty_background_ratio&nbsp;来控制，比如下面的参数显示脏页面（dirty pages）达到所有内存页面10％的时候开始写入硬盘。</p>
<p># /sbin/sysctl -n vm.dirty_background_ratio &nbsp;10</p>
<p><strong>3.1&nbsp;&nbsp;vmstat</strong></p>
<pre class="prettyprint linenums"># vmstat 1</pre>
<pre class="prettyprint linenums">procs -----------memory---------- ---swap-- -----io---- --system-- -----cpu------</pre>
<pre class="prettyprint linenums"> r&nbsp; b&nbsp;&nbsp; swpd&nbsp;&nbsp; free&nbsp;&nbsp; buff&nbsp; cache&nbsp;&nbsp; si&nbsp;&nbsp; so&nbsp;&nbsp;&nbsp; bi&nbsp;&nbsp;&nbsp; bo&nbsp;&nbsp; in&nbsp;&nbsp; cs us sy id wa st</pre>
<pre class="prettyprint linenums"> 0&nbsp; 3 252696&nbsp;&nbsp; 2432&nbsp;&nbsp;&nbsp; 268&nbsp;&nbsp; 7148 3604 2368&nbsp; 3608&nbsp; 2372&nbsp; 288&nbsp; 288&nbsp; 0&nbsp; 0 21 78&nbsp; 1</pre>
<pre class="prettyprint linenums"> 0&nbsp; 2 253484&nbsp;&nbsp; 2216&nbsp;&nbsp;&nbsp; 228&nbsp;&nbsp; 7104 5368 2976&nbsp; 5372&nbsp; 3036&nbsp; 930&nbsp; 519&nbsp; 0&nbsp; 0&nbsp; 0 100&nbsp; 0</pre>
<pre class="prettyprint linenums"> 0&nbsp; 1 259252&nbsp;&nbsp; 2616&nbsp;&nbsp;&nbsp; 128&nbsp;&nbsp; 6148 19784 18712 19784 18712 3821 1853&nbsp; 0&nbsp; 1&nbsp; 3 95&nbsp; 1</pre>
<pre class="prettyprint linenums"> 1&nbsp; 2 260008&nbsp;&nbsp; 2188&nbsp;&nbsp;&nbsp; 144&nbsp;&nbsp; 6824 11824 2584 12664&nbsp; 2584 1347 1174 14&nbsp; 0&nbsp; 0 86&nbsp; 0</pre>
<pre class="prettyprint linenums"> 2&nbsp; 1 262140&nbsp;&nbsp; 2964&nbsp;&nbsp;&nbsp; 128&nbsp;&nbsp; 5852 24912 17304 24952 17304 4737 2341 86 10&nbsp; 0&nbsp; 0&nbsp; 4</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">部分参数说明：</pre>
<p>（1）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;swpd，已使用的&nbsp;SWAP&nbsp;空间大小，KB&nbsp;为单位；</p>
<p>（2）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;free，可用的物理内存大小，KB&nbsp;为单位；</p>
<p>（3）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;buff，物理内存用来缓存读写操作的&nbsp;buffer&nbsp;大小，KB&nbsp;为单位；表示buffers&nbsp;cache的内存数量，一般对块设备的读写才需要缓冲。缓存，主要用于目录方面,inode值等（ls &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;大目录可看到这个值增加）</p>
<p>（4）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;cache，物理内存用来缓存进程地址空间的&nbsp;cache&nbsp;大小，KB&nbsp;为单位；表示page&nbsp;cached的内存数量，一般作为文件系统cached，频繁访问的文件都会被cached，如果 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;cache值较大，说明cached的文件数较多，如果此时IO中bi比较小，说明文件系统效率比较好。缓存，用于已打开的文件。</p>
<p>（5）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;si，数据从&nbsp;SWAP&nbsp;读取到&nbsp;RAM（swap in）的大小，KB&nbsp;为单位；</p>
<p>（6）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;so，数据从&nbsp;RAM&nbsp;写到&nbsp;SWAP（swap out）的大小，KB&nbsp;为单位；</p>
<p>（7）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;bi，磁盘块从文件系统或&nbsp;SWAP&nbsp;读取到&nbsp;RAM（blocks in）的大小，block&nbsp;为单位；</p>
<p>（8）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;bo，磁盘块从&nbsp;RAM&nbsp;写到文件系统或&nbsp;SWAP（blocks out）的大小，block&nbsp;为单位；</p>
<p>上面是一个频繁读写交换区的例子，可以观察到以下几点：</p>
<p>（1）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;物理可用内存&nbsp;free&nbsp;基本没什么显著变化，swapd&nbsp;逐步增加，说明最小可用的内存始终保持在&nbsp;256MB(物理内存大小) * 10％&nbsp;= 2.56MB&nbsp;左右，当脏页达到10％的时候（vm.dirty_background_ratio&nbsp;＝&nbsp;10）就开始大量使用&nbsp;swap；</p>
<p>（2）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<strong>buff&nbsp;稳步减少说明系统知道内存不够了，kwapd&nbsp;正在从&nbsp;buff&nbsp;那里借用部分内存；</strong></p>
<p>（3）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;kswapd&nbsp;持续把脏页面写到&nbsp;swap&nbsp;交换区（so），并且从&nbsp;swapd&nbsp;逐渐增加看出确实如此。根据上面讲的&nbsp;kswapd&nbsp;扫描时检查的三件事，如果页面被修改了，但不是被文件系统修改的，把页面写到&nbsp;swap，所以这里&nbsp;swapd&nbsp;持续增加。</p>
<p><strong>四. IO</strong></p>
<p>磁盘通常是计算机最慢的子系统，也是最容易出现性能瓶颈的地方，因为磁盘离&nbsp;CPU&nbsp;距离最远而且&nbsp;CPU&nbsp;访问磁盘要涉及到机械操作，比如转轴、寻轨等。访问硬盘和访问内存之间的速度差别是以数量级来计算的，就像1天和1分钟的差别一样。要监测&nbsp;IO&nbsp;性能，有必要了解一下基本原理和&nbsp;Linux&nbsp;是如何处理硬盘和内存之间的&nbsp;IO&nbsp;的。</p>
<p><strong>4.1&nbsp;内存页</strong></p>
<p>在第三节Memory中提到了内存和硬盘之间的&nbsp;IO&nbsp;是以页为单位来进行的，在&nbsp;Linux&nbsp;系统上1页的大小为&nbsp;4K。可以用以下命令查看系统默认的页面大小：</p>
<p>$ /usr/bin/time -v date</p>
<p>...</p>
<p>Page size (bytes): 4096</p>
<p>...</p>
<p><strong>4.2&nbsp;缺页中断</strong></p>
<p>Linux&nbsp;利用虚拟内存极大的扩展了程序地址空间，使得原来物理内存不能容下的程序也可以通过内存和硬盘之间的不断交换（把暂时不用的内存页交换到硬盘，把需要的内存页从硬盘读到内存）来赢得更多的内存，看起来就像物理内存被扩大了一样。事实上这个过程对程序是完全透明的，程序完全不用理会自己哪一部分、什么时候被交换进内存，一切都有内核的虚拟内存管理来完成。当程序启动的时候，Linux&nbsp;内核首先检查&nbsp;CPU&nbsp;的缓存和物理内存，如果数据已经在内存里就忽略，如果数据不在内存里就引起一个缺页中断（Page Fault），然后从硬盘读取缺页，并把缺页缓存到物理内存里。缺页中断可分为主缺页中断（Major Page Fault）和次缺页中断（Minor Page Fault），要从磁盘读取数据而产生的中断是主缺页中断；数据已经被读入内存并被缓存起来，从内存缓存区中而不是直接从硬盘中读取数据而产生的中断是次缺页中断。</p>
<p><strong>上面的内存缓存区起到了预读硬盘的作用，内核先在物理内存里寻找缺页，没有的话产生次缺页中断从内存缓存里找，如果还没有发现的话就从硬盘读取</strong>。很显然，把多余的内存拿出来做成内存缓存区提高了访问速度，这里还有一个命中率的问题，运气好的话如果每次缺页都能从内存缓存区读取的话将会极大提高性能。要提高命中率的一个简单方法就是增大内存缓存区面积，缓存区越大预存的页面就越多，命中率也会越高。</p>
<p>下面的&nbsp;time&nbsp;命令可以用来查看某程序第一次启动的时候产生了多少主缺页中断和次缺页中断：</p>
<pre class="prettyprint linenums">$ /usr/bin/time -v date</pre>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; ...</pre>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Major (requiring I/O) page faults: 1</pre>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Minor (reclaiming a frame) page faults: 260</pre>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; ...</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<p><strong>4.3&nbsp;&nbsp;File Buffer Cache</strong></p>
<p>从上面的内存缓存区（也叫文件缓存区&nbsp;File Buffer Cache）读取页比从硬盘读取页要快得多，所以&nbsp;Linux&nbsp;内核希望能尽可能产生次缺页中断（从文件缓存区读），并且能尽可能避免主缺页中断（从硬盘读），这样随着次缺页中断的增多，文件缓存区也逐步增大，直到系统只有少量可用物理内存的时候&nbsp;Linux&nbsp;才开始释放一些不用的页。我们运行&nbsp;Linux&nbsp;一段时间后会发现虽然系统上运行的程序不多，但是可用内存总是很少，这样给大家造成了&nbsp;Linux&nbsp;对内存管理很低效的假象，事实上&nbsp;Linux&nbsp;把那些暂时不用的物理内存高效的利用起来做预存（内存缓存区）呢。下面是一台&nbsp;Sun&nbsp;服务器上的物理内存和文件缓存区的情况：</p>
<pre class="prettyprint linenums">$ cat /proc/meminfo</pre>
<pre class="prettyprint linenums">MemTotal:&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;8182776 kB</pre>
<pre class="prettyprint linenums">MemFree:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 3053808 kB</pre>
<pre class="prettyprint linenums">Buffers:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 342704 kB</pre>
<pre class="prettyprint linenums">Cached:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 3972748 kB</pre>
<p>这台服务器总共有&nbsp;8GB&nbsp;物理内存（MemTotal），3GB&nbsp;左右可用内存（MemFree），343MB&nbsp;左右用来做磁盘缓存（Buffers），4GB&nbsp;左右用来做文件缓存区（Cached），可见&nbsp;Linux&nbsp;真的用了很多物理内存做&nbsp;Cache，而且这个缓存区还可以不断增长。</p>
<p><strong>4.4&nbsp;页面类型</strong></p>
<p>Linux&nbsp;中内存页面有三种类型：</p>
<p>（1）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Read pages，只读页（或代码页），那些通过主缺页中断从硬盘读取的页面，包括不能修改的静态文件、可执行文件、库文件等。当内核需要它们的时候把它们读到内存中，当内存不足的时候，内核就释放它们到空闲列表，当程序再次需要它们的时候需要通过缺页中断再次读到内存。</p>
<p>（2）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Dirty pages，脏页，指那些在内存中被修改过的数据页，比如文本文件等。这些文件由&nbsp;pdflush&nbsp;负责同步到硬盘，内存不足的时候由&nbsp;kswapd&nbsp;和&nbsp;pdflush&nbsp;把数据写回硬盘并释放内存。</p>
<p>（3）.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Anonymous pages，匿名页，那些属于某个进程但是又和任何文件无关联，不能被同步到硬盘上，内存不足的时候由&nbsp;kswapd&nbsp;负责将它们写到交换分区并释放内存。</p>
<p><strong>4.5&nbsp;&nbsp;IO&rsquo;s Per Second（IOPS）</strong></p>
<p>每次磁盘&nbsp;IO&nbsp;请求都需要一定的时间，和访问内存比起来这个等待时间简直难以忍受。在一台&nbsp;2001&nbsp;年的典型&nbsp;1GHz PC&nbsp;上，磁盘随机访问一个&nbsp;word&nbsp;需要&nbsp;8,000,000 nanosec = 8 millisec，顺序访问一个&nbsp;word&nbsp;需要&nbsp;200 nanosec；而从内存访问一个&nbsp;word&nbsp;只需要&nbsp;10 nanosec.（数据来自：<a href="http://norvig.com/21-days.html" rel="external nofollow noreferrer">Teach Yourself Programming in Ten Years</a>）这个硬盘可以提供&nbsp;125&nbsp;次&nbsp;IOPS（1000 ms / 8 ms）。</p>
<p><strong>4.6&nbsp;&nbsp;顺序&nbsp;IO&nbsp;和&nbsp;随机&nbsp;IO</strong></p>
<p>IO&nbsp;可分为顺序&nbsp;IO&nbsp;和&nbsp;随机&nbsp;IO&nbsp;两种，性能监测前需要弄清楚系统偏向顺序&nbsp;IO&nbsp;的应用还是随机&nbsp;IO&nbsp;应用。</p>
<p>（1）顺序&nbsp;IO&nbsp;是指同时顺序请求大量数据，比如数据库执行大量的查询、流媒体服务等，顺序&nbsp;IO&nbsp;可以同时很快的移动大量数据。可以这样来评估&nbsp;IOPS&nbsp;的性能，用每秒读写&nbsp;IO&nbsp;字节数除以每秒读写&nbsp;IOPS&nbsp;数，rkB/s&nbsp;除以&nbsp;r/s，wkB/s&nbsp;除以&nbsp;w/s.&nbsp;下面显示的是连续2秒的&nbsp;IO&nbsp;情况，可见每次&nbsp;IO&nbsp;写的数据是增加的（45060.00 / 99.00 = 455.15 KB per IO，54272.00 / 112.00 = 484.57 KB per IO）。</p>
<p>相对随机&nbsp;IO&nbsp;而言，<strong>顺序&nbsp;IO&nbsp;更应该重视每次&nbsp;IO&nbsp;的吞吐能力（KB per IO）</strong>：</p>
<pre class="prettyprint linenums">$ iostat -kx 1</pre>
<pre class="prettyprint linenums">avg-cpu:&nbsp; %user&nbsp;&nbsp; %nice %system %iowait&nbsp; %steal&nbsp;&nbsp; %idle</pre>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 2.50&nbsp;&nbsp; 25.25&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp; 72.25</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">Device:&nbsp; rrqm/s&nbsp;&nbsp; wrqm/s&nbsp;&nbsp; r/s&nbsp;&nbsp; w/s&nbsp;&nbsp;&nbsp; rkB/s&nbsp;&nbsp;&nbsp; wkB/s avgrq-sz avgqu-sz&nbsp;&nbsp; await&nbsp; svctm&nbsp; %util</pre>
<pre class="prettyprint linenums">sdb&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 24.00 19995.00 29.00 99.00&nbsp; 4228.00 45060.00&nbsp;&nbsp; 770.12&nbsp;&nbsp;&nbsp; 45.01&nbsp; 539.65&nbsp;&nbsp; 7.80&nbsp; 99.80</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">avg-cpu:&nbsp; %user&nbsp;&nbsp; %nice %system %iowait&nbsp; %steal&nbsp;&nbsp; %idle</pre>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 1.00&nbsp;&nbsp; 30.67&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp; 68.33</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">Device:&nbsp; rrqm/s&nbsp;&nbsp; wrqm/s&nbsp;&nbsp; r/s&nbsp;&nbsp; w/s&nbsp;&nbsp;&nbsp; rkB/s&nbsp;&nbsp;&nbsp; wkB/s avgrq-sz avgqu-sz&nbsp;&nbsp; await&nbsp; svctm&nbsp; %util</pre>
<pre class="prettyprint linenums">sdb&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 3.00 12235.00&nbsp; 3.00 112.00&nbsp;&nbsp; 768.00 54272.00&nbsp;&nbsp; 957.22&nbsp;&nbsp; 144.85&nbsp; 576.44&nbsp;&nbsp; 8.70 100.10</pre>
<p>（2）随机&nbsp;IO&nbsp;是指随机请求数据，其&nbsp;IO&nbsp;速度不依赖于数据的大小和排列，依赖于磁盘的每秒能&nbsp;IO&nbsp;的次数，比如&nbsp;Web&nbsp;服务、Mail&nbsp;服务等每次请求的数据都很小，随机&nbsp;IO&nbsp;每秒同时会有更多的请求数产生，所以磁盘的每秒能&nbsp;IO&nbsp;多少次是关键。</p>
<pre class="prettyprint linenums">$ iostat -kx 1</pre>
<pre class="prettyprint linenums">avg-cpu:&nbsp; %user&nbsp;&nbsp; %nice %system %iowait&nbsp; %steal&nbsp;&nbsp; %idle</pre>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 1.75&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.75&nbsp;&nbsp;&nbsp; 0.25&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp; 97.26</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">Device:&nbsp; rrqm/s&nbsp;&nbsp; wrqm/s&nbsp;&nbsp; r/s&nbsp;&nbsp; w/s&nbsp;&nbsp;&nbsp; rkB/s&nbsp;&nbsp;&nbsp; wkB/s avgrq-sz avgqu-sz&nbsp;&nbsp; await&nbsp; svctm&nbsp; %util</pre>
<pre class="prettyprint linenums">sdb&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 52.00&nbsp; 0.00 57.00&nbsp;&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp; 436.00&nbsp;&nbsp;&nbsp; 15.30&nbsp;&nbsp;&nbsp;&nbsp; 0.03&nbsp;&nbsp;&nbsp; 0.54&nbsp;&nbsp; 0.23&nbsp;&nbsp; 1.30</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">avg-cpu:&nbsp; %user&nbsp;&nbsp; %nice %system %iowait&nbsp; %steal&nbsp;&nbsp; %idle</pre>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 1.75&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 0.75&nbsp;&nbsp;&nbsp; 0.25&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp; 97.24</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">Device:&nbsp; rrqm/s&nbsp;&nbsp; wrqm/s&nbsp;&nbsp; r/s&nbsp;&nbsp; w/s&nbsp;&nbsp;&nbsp; rkB/s&nbsp;&nbsp;&nbsp; wkB/s avgrq-sz avgqu-sz&nbsp;&nbsp; await&nbsp; svctm&nbsp; %util</pre>
<pre class="prettyprint linenums">sdb&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp;&nbsp; 56.44&nbsp; 0.00 66.34&nbsp;&nbsp;&nbsp;&nbsp; 0.00&nbsp;&nbsp; 491.09&nbsp;&nbsp;&nbsp; 14.81&nbsp;&nbsp;&nbsp;&nbsp; 0.04&nbsp;&nbsp;&nbsp; 0.54&nbsp;&nbsp; 0.19&nbsp;&nbsp; 1.29</pre>
<p>按照上面的公式得出：436.00 / 57.00 = 7.65 KB per IO，491.09 / 66.34 = 7.40 KB per IO.&nbsp;与顺序&nbsp;IO&nbsp;比较发现，随机&nbsp;IO&nbsp;的&nbsp;KB per IO&nbsp;小到可以忽略不计，可见<strong>对于随机&nbsp;IO&nbsp;而言重要的是每秒能&nbsp;IOPS&nbsp;的次数，而不是每次&nbsp;IO&nbsp;的吞吐能力（KB per IO）。</strong></p>
<p><strong>4.7 SWAP</strong></p>
<p>当系统没有足够物理内存来应付所有请求的时候就会用到&nbsp;swap&nbsp;设备，swap&nbsp;设备可以是一个文件，也可以是一个磁盘分区。不过要小心的是，使用&nbsp;swap&nbsp;的代价非常大。<strong>如果系统没有物理内存可用，就会频繁&nbsp;swapping，如果&nbsp;swap&nbsp;设备和程序正要访问的数据在同一个文件系统上，那会碰到严重的&nbsp;IO&nbsp;问题，最终导致整个系统迟缓，甚至崩溃。</strong>swap&nbsp;设备和内存之间的&nbsp;swapping&nbsp;状况是判断&nbsp;Linux&nbsp;系统性能的重要参考，我们已经有很多工具可以用来监测&nbsp;swap&nbsp;和&nbsp;swapping&nbsp;情况，比如：top、cat /proc/meminfo、vmstat&nbsp;等：</p>
<pre class="prettyprint linenums">$ cat /proc/meminfo</pre>
<pre class="prettyprint linenums">MemTotal:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 8182776 kB</pre>
<pre class="prettyprint linenums">MemFree:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 2125476 kB</pre>
<pre class="prettyprint linenums">Buffers:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 347952 kB</pre>
<pre class="prettyprint linenums">Cached:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 4892024 kB</pre>
<pre class="prettyprint linenums">SwapCached:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 112 kB</pre>
<pre class="prettyprint linenums">...</pre>
<pre class="prettyprint linenums">SwapTotal:&nbsp;&nbsp;&nbsp;&nbsp; 4096564 kB</pre>
<pre class="prettyprint linenums">SwapFree:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 4096424 kB</pre>
<pre class="prettyprint linenums">...</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">$ vmstat 1</pre>
<pre class="prettyprint linenums">procs -----------memory---------- ---swap-- -----io---- --system-- -----cpu------</pre>
<pre class="prettyprint linenums"> r&nbsp; b&nbsp;&nbsp; swpd&nbsp;&nbsp; free&nbsp;&nbsp; buff&nbsp; cache&nbsp;&nbsp; si&nbsp;&nbsp; so&nbsp;&nbsp;&nbsp; bi&nbsp;&nbsp;&nbsp; bo&nbsp;&nbsp; in&nbsp;&nbsp; cs us sy id wa st</pre>
<pre class="prettyprint linenums"> 1&nbsp; 2 260008&nbsp;&nbsp; 2188&nbsp;&nbsp;&nbsp; 144&nbsp;&nbsp; 6824 11824 2584 12664&nbsp; 2584 1347 1174 14&nbsp; 0&nbsp; 0 86&nbsp; 0</pre>
<pre class="prettyprint linenums"> 2&nbsp; 1 262140&nbsp;&nbsp; 2964&nbsp;&nbsp;&nbsp; 128&nbsp;&nbsp; 5852 24912 17304 24952 17304 4737 2341 86 10&nbsp; 0&nbsp; 0</pre>
<p><strong>五. network</strong></p>
<p>网络的监测是所有&nbsp;Linux&nbsp;子系统里面最复杂的，有太多的因素在里面，比如：延迟、阻塞、冲突、丢包等，更糟的是与&nbsp;Linux&nbsp;主机相连的路由器、交换机、无线信号都会影响到整体网络并且很难判断是因为&nbsp;Linux&nbsp;网络子系统的问题还是别的设备的问题，增加了监测和判断的复杂度。现在我们使用的所有网卡都称为自适应网卡，意思是说能根据网络上的不同网络设备导致的不同网络速度和工作模式进行自动调整。我们可以通过&nbsp;ethtool&nbsp;工具来查看网卡的配置和工作模式：</p>
<pre class="prettyprint linenums"># /sbin/ethtool eth0</pre>
<pre class="prettyprint linenums">Settings for eth0:</pre>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Supported ports: [ TP ]</pre>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Supported link modes:&nbsp;&nbsp; 10baseT/Half 10baseT/Full</pre>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 100baseT/Half 100baseT/Full</pre>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 1000baseT/Half 1000baseT/Full</pre>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Supports auto-negotiation: Yes</pre>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Advertised link modes:&nbsp; 10baseT/Half 10baseT/Full</pre>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 100baseT/Half 100baseT/Full</pre>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 1000baseT/Half 1000baseT/Full</pre>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Advertised auto-negotiation: Yes</pre>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Speed: 100Mb/s</pre>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Duplex: Full</pre>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Port: Twisted Pair</pre>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; PHYAD: 1</pre>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Transceiver: internal</pre>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Auto-negotiation: on</pre>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Supports Wake-on: g</pre>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Wake-on: g</pre>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Current message level: 0x000000ff (255)</pre>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Link detected: yes</pre>
<p>上面给出的例子说明网卡有&nbsp;10baseT，100baseT&nbsp;和&nbsp;1000baseT&nbsp;三种选择，目前正自适应为&nbsp;100baseT（Speed: 100Mb/s）。可以通过&nbsp;ethtool&nbsp;工具强制网卡工作在&nbsp;1000baseT&nbsp;下：</p>
<pre class="prettyprint linenums"># /sbin/ethtool -s eth0 speed 1000 duplex full autoneg off</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<p><strong>5.1&nbsp;&nbsp;iptraf</strong></p>
<p>两台主机之间有网线（或无线）、路由器、交换机等设备，测试两台主机之间的网络性能的一个办法就是在这两个系统之间互发数据并统计结果，看看吞吐量、延迟、速率如何。iptraf&nbsp;就是一个很好的查看本机网络吞吐量的好工具，支持文字图形界面，很直观。下面图片显示在&nbsp;100 mbps&nbsp;速率的网络下这个&nbsp;Linux&nbsp;系统的发送传输率有点慢，Outgoing rates&nbsp;只有&nbsp;66 mbps.</p>
<pre class="prettyprint linenums"># iptraf -d eth0</pre>
<p><img referrerpolicy="no-referrer"src="http://www.vpsee.com/wp-content/uploads/2009/11/linux-system-performance-monitoring-network-1.png" /></p>
<pre class="prettyprint linenums"></pre>
<p><strong>5.2&nbsp;&nbsp;netperf</strong></p>
<p>netperf&nbsp;运行在&nbsp;client/server&nbsp;模式下，比&nbsp;iptraf&nbsp;能更多样化的测试终端的吞吐量。先在服务器端启动&nbsp;netserver：</p>
<pre class="prettyprint linenums"># netserver</pre>
<pre class="prettyprint linenums">Starting netserver at port 12865</pre>
<pre class="prettyprint linenums">Starting netserver at hostname 0.0.0.0 port 12865 and family AF_UNSPEC</pre>
<p>然后在客户端测试服务器，执行一次持续10秒的&nbsp;TCP&nbsp;测试：</p>
<pre class="prettyprint linenums"># netperf -H 172.16.38.36 -l 10</pre>
<pre class="prettyprint linenums">TCP STREAM TEST from 0.0.0.0 (0.0.0.0) port 0 AF_INET to 172.16.38.36 (172.16.38.36) port 0 AF_INET</pre>
<pre class="prettyprint linenums">Recv&nbsp;&nbsp; Send&nbsp;&nbsp;&nbsp; Send</pre>
<pre class="prettyprint linenums">Socket Socket&nbsp; Message&nbsp; Elapsed</pre>
<pre class="prettyprint linenums">Size&nbsp;&nbsp; Size&nbsp;&nbsp;&nbsp; Size&nbsp;&nbsp;&nbsp;&nbsp; Time&nbsp;&nbsp;&nbsp;&nbsp; Throughput</pre>
<pre class="prettyprint linenums">bytes&nbsp; bytes&nbsp;&nbsp; bytes&nbsp;&nbsp;&nbsp; secs.&nbsp;&nbsp;&nbsp; 10^6bits/sec&nbsp; </pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums"> 87380&nbsp; 16384&nbsp; 16384&nbsp;&nbsp;&nbsp; 10.32&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 93.68</pre>
<p>从以上输出可以看出，网络吞吐量在&nbsp;94mbps&nbsp;左右，对于&nbsp;100mbps&nbsp;的网络来说这个性能算的上很不错。上面的测试是在服务器和客户端位于同一个局域网，并且局域网是有线网的情况，你也可以试试不同结构、不同速率的网络，比如：网络之间中间多几个路由器、客户端在&nbsp;wi-fi、VPN&nbsp;等情况。</p>
<p>netperf&nbsp;还可以通过建立一个&nbsp;TCP&nbsp;连接并顺序地发送数据包来测试每秒有多少&nbsp;TCP&nbsp;请求和响应。下面的输出显示在&nbsp;TCP requests&nbsp;使用&nbsp;2K&nbsp;大小，responses&nbsp;使用&nbsp;32K&nbsp;的情况下处理速率为每秒243：</p>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums"># netperf -t TCP_RR -H 172.16.38.36 -l 10 -- -r 2048,32768</pre>
<pre class="prettyprint linenums">TCP REQUEST/RESPONSE TEST from 0.0.0.0 (0.0.0.0) port 0 AF_INET to 172.16.38.36 (172.16.38.36) port 0 AF_INET</pre>
<pre class="prettyprint linenums">Local /Remote</pre>
<pre class="prettyprint linenums">Socket Size&nbsp;&nbsp; Request&nbsp; Resp.&nbsp;&nbsp; Elapsed&nbsp; Trans.</pre>
<pre class="prettyprint linenums">Send&nbsp;&nbsp; Recv&nbsp;&nbsp; Size&nbsp;&nbsp;&nbsp;&nbsp; Size&nbsp;&nbsp;&nbsp; Time&nbsp;&nbsp;&nbsp;&nbsp; Rate</pre>
<pre class="prettyprint linenums">bytes&nbsp; Bytes&nbsp; bytes&nbsp;&nbsp;&nbsp; bytes&nbsp;&nbsp; secs.&nbsp;&nbsp;&nbsp; per sec&nbsp;&nbsp; </pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">16384&nbsp; 87380&nbsp; 2048&nbsp;&nbsp;&nbsp;&nbsp; 32768&nbsp;&nbsp; 10.00&nbsp;&nbsp;&nbsp;&nbsp; 243.03</pre>
<pre class="prettyprint linenums">16384&nbsp; 87380</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<p><strong>5.3&nbsp;&nbsp;iperf</strong></p>
<p>iperf&nbsp;和&nbsp;netperf&nbsp;运行方式类似，也是&nbsp;server/client&nbsp;模式，先在服务器端启动&nbsp;iperf：</p>
<pre class="prettyprint linenums"># iperf -s -D</pre>
<pre class="prettyprint linenums">------------------------------------------------------------</pre>
<pre class="prettyprint linenums">Server listening on TCP port 5001</pre>
<pre class="prettyprint linenums">TCP window size: 85.3 KByte (default)</pre>
<pre class="prettyprint linenums">------------------------------------------------------------</pre>
<pre class="prettyprint linenums">Running Iperf Server as a daemon</pre>
<pre class="prettyprint linenums">The Iperf daemon process ID : 5695</pre>
<p>然后在客户端对服务器进行测试，客户端先连接到服务器端（172.16.38.36），并在30秒内每隔5秒对服务器和客户端之间的网络进行一次带宽测试和采样：</p>
<pre class="prettyprint linenums"># iperf -c 172.16.38.36 -t 30 -i 5</pre>
<pre class="prettyprint linenums">------------------------------------------------------------</pre>
<pre class="prettyprint linenums">Client connecting to 172.16.38.36, TCP port 5001</pre>
<pre class="prettyprint linenums">TCP window size: 16.0 KByte (default)</pre>
<pre class="prettyprint linenums">------------------------------------------------------------</pre>
<pre class="prettyprint linenums">[&nbsp; 3] local 172.16.39.100 port 49515 connected with 172.16.38.36 port 5001</pre>
<pre class="prettyprint linenums">[ ID] Interval&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Transfer&nbsp;&nbsp;&nbsp;&nbsp; Bandwidth</pre>
<pre class="prettyprint linenums">[&nbsp; 3]&nbsp; 0.0- 5.0 sec&nbsp; 58.8 MBytes&nbsp; 98.6 Mbits/sec</pre>
<pre class="prettyprint linenums">[ ID] Interval&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Transfer&nbsp;&nbsp;&nbsp;&nbsp; Bandwidth</pre>
<pre class="prettyprint linenums">[&nbsp; 3]&nbsp; 5.0-10.0 sec&nbsp; 55.0 MBytes&nbsp; 92.3 Mbits/sec</pre>
<pre class="prettyprint linenums">[ ID] Interval&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Transfer&nbsp;&nbsp;&nbsp;&nbsp; Bandwidth</pre>
<pre class="prettyprint linenums">[&nbsp; 3] 10.0-15.0 sec&nbsp; 55.1 MBytes&nbsp; 92.4 Mbits/sec</pre>
<pre class="prettyprint linenums">[ ID] Interval&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Transfer&nbsp;&nbsp;&nbsp;&nbsp; Bandwidth</pre>
<pre class="prettyprint linenums">[&nbsp; 3] 15.0-20.0 sec&nbsp; 55.9 MBytes&nbsp; 93.8 Mbits/sec</pre>
<pre class="prettyprint linenums">[ ID] Interval&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Transfer&nbsp;&nbsp;&nbsp;&nbsp; Bandwidth</pre>
<pre class="prettyprint linenums">[&nbsp; 3] 20.0-25.0 sec&nbsp; 55.4 MBytes&nbsp; 92.9 Mbits/sec</pre>
<pre class="prettyprint linenums">[ ID] Interval&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Transfer&nbsp;&nbsp;&nbsp;&nbsp; Bandwidth</pre>
<pre class="prettyprint linenums">[&nbsp; 3] 25.0-30.0 sec&nbsp; 55.3 MBytes&nbsp; 92.8 Mbits/sec</pre>
<pre class="prettyprint linenums">[ ID] Interval&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Transfer&nbsp;&nbsp;&nbsp;&nbsp; Bandwidth</pre>
<pre class="prettyprint linenums">[&nbsp; 3]&nbsp; 0.0-30.0 sec&nbsp;&nbsp;&nbsp; 335 MBytes&nbsp; 93.7 Mbits/sec</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<p><strong>5.4&nbsp;&nbsp;tcpdump&nbsp;和&nbsp;tcptrace</strong></p>
<p>tcmdump&nbsp;和&nbsp;tcptrace&nbsp;提供了一种更细致的分析方法，先用&nbsp;tcpdump&nbsp;按要求捕获数据包把结果输出到某一文件，然后再用&nbsp;tcptrace&nbsp;分析其文件格式。这个工具组合可以提供一些难以用其他工具发现的信息：</p>
<pre class="prettyprint linenums"># /usr/sbin/tcpdump -w network.dmp</pre>
<pre class="prettyprint linenums">tcpdump: listening on eth0, link-type EN10MB (Ethernet), capture size 96 bytes</pre>
<pre class="prettyprint linenums">511942 packets captured</pre>
<pre class="prettyprint linenums">511942 packets received by filter</pre>
<pre class="prettyprint linenums">0 packets dropped by kernel</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums"># tcptrace network.dmp</pre>
<pre class="prettyprint linenums">1 arg remaining, starting with 'network.dmp'</pre>
<pre class="prettyprint linenums">Ostermann's tcptrace -- version 6.6.7 -- Thu Nov&nbsp; 4, 2004</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">511677 packets seen, 511487 TCP packets traced</pre>
<pre class="prettyprint linenums">elapsed wallclock time: 0:00:00.510291, 1002714 pkts/sec analyzed</pre>
<pre class="prettyprint linenums">trace file elapsed time: 0:02:35.836372</pre>
<pre class="prettyprint linenums">TCP connection info:</pre>
<pre class="prettyprint linenums">&nbsp; 1: zaber:54581 - boulder:111 (a2b)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 6&gt;&nbsp;&nbsp;&nbsp; 5&lt;&nbsp; (complete)</pre>
<pre class="prettyprint linenums">&nbsp; 2: zaber:833 - boulder:32774 (c2d)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 6&gt;&nbsp;&nbsp;&nbsp; 5&lt;&nbsp; (complete)</pre>
<pre class="prettyprint linenums">&nbsp; 3: zaber:pcanywherestat - 172.16.39.5:53086 (e2f)&nbsp;&nbsp;&nbsp; 2&gt;&nbsp;&nbsp;&nbsp; 3&lt;</pre>
<pre class="prettyprint linenums">&nbsp; 4: zaber:716 - boulder:2049 (g2h)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 347&gt;&nbsp; 257&lt;</pre>
<pre class="prettyprint linenums">&nbsp; 5: 172.16.39.100:58029 - zaber:12865 (i2j)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 7&gt;&nbsp;&nbsp;&nbsp; 5&lt;&nbsp; (complete)</pre>
<pre class="prettyprint linenums">&nbsp; 6: 172.16.39.100:47592 - zaber:36814 (k2l)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 255380&gt; 255378&lt;&nbsp; (reset)</pre>
<pre class="prettyprint linenums">&nbsp; 7: breakpoint:45510 - zaber:7012 (m2n)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 9&gt;&nbsp;&nbsp;&nbsp; 5&lt;&nbsp; (complete)</pre>
<pre class="prettyprint linenums">&nbsp; 8: zaber:35813 - boulder:111 (o2p)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 6&gt;&nbsp;&nbsp;&nbsp; 5&lt;&nbsp; (complete)</pre>
<pre class="prettyprint linenums">&nbsp; 9: zaber:837 - boulder:32774 (q2r)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 6&gt;&nbsp;&nbsp;&nbsp; 5&lt;&nbsp; (complete)</pre>
<pre class="prettyprint linenums"> 10: breakpoint:45511 - zaber:7012 (s2t)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 9&gt;&nbsp;&nbsp;&nbsp; 5&lt;&nbsp; (complete)</pre>
<pre class="prettyprint linenums"> 11: zaber:59362 - boulder:111 (u2v)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 6&gt;&nbsp;&nbsp;&nbsp; 5&lt;&nbsp; (complete)</pre>
<pre class="prettyprint linenums"> 12: zaber:841 - boulder:32774 (w2x)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;6&gt;&nbsp;&nbsp;&nbsp; 5&lt;&nbsp; (complete)</pre>
<pre class="prettyprint linenums"> 13: breakpoint:45512 - zaber:7012 (y2z)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 9&gt;&nbsp;&nbsp;&nbsp; 5&lt;&nbsp; (complete)</pre>
<p>tcptrace&nbsp;功能很强大，还可以通过过滤和布尔表达式来找出有问题的连接，比如，找出转播大于100 segments&nbsp;的连接：</p>
<pre class="prettyprint linenums"># tcptrace -f'rexmit_segs&gt;100' network.dmp</pre>
<p>如果发现连接&nbsp;＃10&nbsp;有问题，可以查看关于这个连接的其他信息：</p>
<pre class="prettyprint linenums"># tcptrace -o10 network.dmp</pre>
<p>下面的命令使用&nbsp;tcptrace&nbsp;的&nbsp;slice&nbsp;模式，程序自动在当前目录创建了一个&nbsp;slice.dat&nbsp;文件，这个文件包含了每隔15秒的转播信息:</p>
<pre class="prettyprint linenums"># tcptrace -xslice network.dmp</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums"># cat slice.dat</pre>
<pre class="prettyprint linenums">date&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; segs&nbsp;&nbsp;&nbsp; bytes&nbsp; rexsegs rexbytes&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; new&nbsp;&nbsp; active</pre>
<pre class="prettyprint linenums">--------------- -------- -------- -------- -------- -------- --------</pre>
<pre class="prettyprint linenums">16:58:50.244708&nbsp;&nbsp;&nbsp; 85055&nbsp; 4513418&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 6&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 6</pre>
<pre class="prettyprint linenums">16:59:05.244708&nbsp;&nbsp; 110921&nbsp; 5882896&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 2</pre>
<pre class="prettyprint linenums">16:59:20.244708&nbsp;&nbsp; 126107&nbsp; 6697827&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 1&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 3</pre>
<pre class="prettyprint linenums">16:59:35.244708&nbsp;&nbsp; 151719&nbsp; 8043597&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 2</pre>
<pre class="prettyprint linenums">16:59:50.244708&nbsp;&nbsp;&nbsp; 37296&nbsp; 1980557&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 3</pre>
<pre class="prettyprint linenums">17:00:05.244708&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 67&nbsp;&nbsp;&nbsp;&nbsp; 8828&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 2&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 3</pre>
<pre class="prettyprint linenums">17:00:20.244708&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 149&nbsp;&nbsp;&nbsp; 22053&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 1&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 2</pre>
<pre class="prettyprint linenums">17:00:35.244708&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 30&nbsp;&nbsp;&nbsp;&nbsp; 4080&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 1</pre>
<pre class="prettyprint linenums">17:00:50.244708&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 39&nbsp;&nbsp;&nbsp;&nbsp; 5688&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 1</pre>
<pre class="prettyprint linenums">17:01:05.244708&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 67&nbsp;&nbsp;&nbsp;&nbsp; 8828&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 2&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 3</pre>
<pre class="prettyprint linenums">17:01:11.081080&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 37&nbsp;&nbsp;&nbsp;&nbsp; 4121&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 1&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 3</pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kpjdr9.html">BZOJ 4668&colon; 冷战</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxjxvz9.html">matlab坐标外围背景变白色</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k66ojq.html">zoom作用</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93znyzq.html">禁用iOS的UIView长按默认操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql64meq.html">JSP过滤器Filter配置过滤类型汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn165o38.html">python学习笔记--Django入门三  Django 与数据库的交互：数据建模</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1eg338.html">&lpar;hdu step 6&period;3&period;1&rpar;Strategic Game&lpar;求用最少顶点数把全部边都覆盖，使用的是邻接表&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1zykz9.html">Object-c学习之路十二（OC的copy）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r2kwo9.html">【算法】LeetCode算法题-Longest Common Prefix</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlloy06q.html">servlet 上下文</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1ze75q.html">oracle 数据库密码过期</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv77py8.html">python基础学习19----socket网络编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppdwk49.html">THE TOOLS TO MANAGE YOUR DATA ACROSS CLOUDS</a>
		</li>
						<li><a href="https://www.batexi.com/a/953zr4v8.html">Python解析xml与JSON</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk6wx38.html">HNOI2018退役记</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkd5wd8.html">JSP之登录验证码</a>
		</li>
						<li><a href="https://www.batexi.com/a/93jv7o08.html">java线程小结1</a>
		</li>
						<li><a href="https://www.batexi.com/a/90dkjzj8.html">apache ab 测试 apr&lowbar;socket&lowbar;connect&lpar;&rpar;&colon; 由于目标机器积极拒绝 无法连接</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2xyyyx9.html">&lbrack;luoguP4306&rsqb;&lbrack;JSOI2010&rsqb;连通数</a>
		</li>
						<li><a href="https://www.batexi.com/a/95pl6r0q.html">03 MD5加密、Base64处理</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q4p2rweq.html">&lpar;一&rpar;jQuery EasyUI 的EasyLoader载入原理</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zk2ddn8.html">CCToggleVisibility和CCPlace</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kol3n7q.html">UTF8字符串在lua的截取和字数统计【转载】</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnnkrlxq.html">c&num; 封装的7zip压缩 （全源码，不含任何类库）</a>
			</li>
						<li><a href="https://www.batexi.com/a/963k6gn9.html">临界区＆Monitor</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vng10q.html">Ribbon的配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gp61re9.html">NIS &amp;amp&semi; Kerberos配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/9020vkjq.html">ajax 基本语法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2jk0v8.html">C&plus;&plus; - 动态申请数组空间</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwlpvvz9.html">oracle中普通视图和实体试图的区别</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
